#include <iostream>
#include <fstream>
#include <math.h>

#include "curve.h"

using namespace std;

curvy::curvy()
{

}

curvy::curvy(string rfile,string gfile,string bfile)
{
	read(rfile,gfile,bfile);
}

curvy::~curvy()
{

}

const curvy& curvy::operator = (const curvy &rhs)
{
	r = rhs.r;
	g = rhs.g;
	b = rhs.b;
	return *this;
}

void curvy::read_ch(string filename, int ch)
{
	fstream filein;
	
	filein.open(filename.c_str(),ios::in);
	if(!filein.is_open())
		{
		cout<<"File : "<<filename<<" does not exist"<<endl;
		exit(1);
		}
		
	while(!filein.eof())
	{
		point temp;
		filein>>temp.x;
		filein>>temp.y;
		
		switch(ch)
		{
			case 0:
				r.push_back(temp);
				break;
			case 1:
				g.push_back(temp);
				break;
			case 2:
				b.push_back(temp);
				break;
			default:
				break;
		}
	}
	filein.close();
	
	switch(ch)
	{
		case 0:
			r.pop_back();
			break;
		case 1:
			g.pop_back();
			break;
		case 2:
			b.pop_back();
			break;
		default:
			break;
	}
}

void curvy::read(string rfile,string gfile,string bfile)
{
	read_ch(rfile,0);
	read_ch(gfile,1);
	read_ch(bfile,2);
}

void curvy::print_ch(int ch)
{
	switch(ch)
	{
		case 0:
			for(int i=0; i < r.size(); ++i)
				cout<<r[i].x<<"\t"<<r[i].y<<endl;
			break;
		case 1:
			for(int i=0; i < g.size(); ++i)
				cout<<g[i].x<<"\t"<<g[i].y<<endl;
			break;
		case 2:
			for(int i=0; i < b.size(); ++i)
				cout<<b[i].x<<"\t"<<b[i].y<<endl;
			break;
		default:
			break;
	}
	cout<<endl;
}

void curvy::print()
{
	print_ch(0);
	print_ch(1);
	print_ch(2);
}

void curvy::scale(char ch, char xy, double val)
{
double hold = val;
	switch(ch)
	{
		case 0:
			for(int i = 0; i < r.size(); ++i)
				if(xy == 0){
					val *= r[i].x;
					r[i].setx(val);
					val = hold;}
				else{
					val *= r[i].y;
					r[i].sety(val);
					val = hold;}
			break;
		case 1:
			for(int i = 0; i < g.size(); ++i)
				if(xy == 0){
					val *= g[i].x;
					g[i].setx(val);
					val = hold;}
				else{
					val *= g[i].y;
					g[i].sety(val);
					val = hold;}
			break;
		case 2:
			for(int i = 0; i < b.size(); ++i)
				if(xy == 0){
					val *= b[i].x;
					b[i].setx(val);
					val = hold;}
				else{
					val *= b[i].y;
					b[i].sety(val);
					val = hold;}
			break;
		default:
			break;
	}
}

void curvy::sum_channels()
{
int samples = r.size();
	for(int id = 0; id < samples ; ++id)
	{
		double hold = r[id].y + g[id].y + b[id].y;//sum channels at this sample
		r[id].sety(hold);//set channels at this sample
		g[id].sety(hold);
		b[id].sety(hold);
	}
}

void curvy::fit_ch_x(int ch, double hi, double lo)
{
double scale;
double max = 0.0;
double min = 1.0;
int id = 0;
	switch(ch)
	{
		case 0:
			for(id = 0; id < r.size(); ++id)
			{
				if(r[id].x > max)
					max = r[id].x;
				if(r[id].x < min)
					min = r[id].x;
			}
			scale = (hi-lo) / (max-min);
			for(id = 0; id < r.size(); ++id)
				r[id].x = (r[id].x - min) * scale + lo;
		break;
		
		case 1:
			for(id = 0; id < g.size(); ++id)
			{
				if(g[id].x > max)
					max = g[id].x;
				if(g[id].x < min)
					min = g[id].x;
			}
			scale = (hi-lo) / (max-min);
			for(id = 0; id < g.size(); ++id)
				g[id].x = (g[id].x - min) * scale + lo;
		
		break;
		
		case 2:
			for(id = 0; id < b.size(); ++id)
			{
				if(b[id].x > max)
					max = b[id].x;
				if(b[id].x < min)
					min = b[id].x;
			}
			scale = (hi-lo) / (max-min);
			for(id = 0; id < b.size(); ++id)
				b[id].x = (b[id].x - min) * scale + lo;
		
		break;
		
		default:
			break;
	}
}

void curvy::fit_ch_y(int ch, double hi, double lo)
{
double scale;
double max = 0.0;
double min = 1.0;
int id = 0;
	switch(ch)
	{
		case 0:
			for(id = 0; id < r.size(); ++id)
			{
				if(r[id].y > max)
					max = r[id].y;
				if(r[id].y < min)
					min = r[id].y;
			}
			scale = (hi-lo) / (max-min);
			for(id = 0; id < r.size(); ++id)
				r[id].y = (r[id].y - min) * scale + lo;
		break;
		
		case 1:
			for(id = 0; id < g.size(); ++id)
			{
				if(g[id].y > max)
					max = g[id].y;
				if(g[id].y < min)
					min = g[id].y;
			}
			scale = (hi-lo) / (max-min);
			for(id = 0; id < g.size(); ++id)
				g[id].y = (g[id].y - min) * scale + lo;
		
		break;
		
		case 2:
			for(id = 0; id < b.size(); ++id)
			{
				if(b[id].y > max)
					max = b[id].y;
				if(b[id].y < min)
					min = b[id].y;
			}
			scale = (hi-lo) / (max-min);
			for(id = 0; id < b.size(); ++id)
				b[id].y = (b[id].y - min) * scale + lo;
		
		break;
		
		default:
			break;
	}
}

void curvy::fit_x(double hi, double lo)
{
	fit_ch_x(0,hi,lo);
	fit_ch_x(1,hi,lo);
	fit_ch_x(2,hi,lo);
}

void curvy::fit_y(double hi, double lo)
{
	fit_ch_y(0,hi,lo);
	fit_ch_y(1,hi,lo);
	fit_ch_y(2,hi,lo);
}

double curvy::get(char ch, char xy, char id)
{
	switch(ch)
	{
		case 0:
			if(xy == 0)
				return r[id].x;
			else
				return r[id].y;
		break;
		
		case 1:
			if(xy == 0)
				return g[id].x;
			else
				return g[id].y;
		break;
		
		case 2:
			if(xy == 0)
				return b[id].x;
			else
				return b[id].y;
		break;
		
		default:
			break;
	}
}

double curvy::setx(char ch, char id, double val)
{
	switch(ch)
	{
		case 0:
			r[id].setx(val);
		case 1:
			g[id].setx(val);
		case 2:
			b[id].setx(val);
		default:
			break;
		
	}
}

double curvy::sety(char ch, char id, double val)
{
	switch(ch)
	{
		case 0:
			r[id].sety(val);
		case 1:
			g[id].sety(val);
		case 2:
			b[id].sety(val);
		default:
			break;
		
	}
}

int curvy::sz(int id)
{
	switch(id)
	{
		case 0:
			return r.size();
			break;
		case 1:
			return g.size();
			break;
		case 2:
			return b.size();
			break;
		default:
			break;
	}
}

/*
**void curvy::mult_ch(curvy rhs, int ch, int ch1)
**multiplies curvy channel ch by rhs channel ch1
*/
void curvy::mult_ch(curvy rhs, int ch, int ch1)
{
curvy temp;
double hold;double sum = 0.0f;int div = 0;
int offset;//cout<<"ch1 "<<ch1<<"\tch "<<ch<<endl;
	switch(ch)
	{
		case 0:
		offset = (int)(rhs.get(ch1,0,0) - 380)/10;
			for(int id = 0; id < r.size(); ++id)
			{
			hold = r[id].y;//cout<<r[id].x<<"\t"<<hold<<"\t";
				if(id < offset)
					r[id].sety(0.0f);
				else if( id-offset < rhs.sz(ch1) )
				{//cout<<rhs.get(ch1,1,id-offset)<<"\t";
					hold *= rhs.get(ch1,1,id-offset);
					r[id].sety(hold);
				}
				else
					r[id].sety(0.0f);
				//cout<<r[id].y<<endl;
			}//cout<<sum<<endl<<endl;
		break;
		
		case 1:
		offset = (int)(rhs.get(ch1,0,0) - 380)/10;
			for(int id = 0; id < g.size(); ++id)
			{sum+=hold;
			hold = g[id].y;//cout<<g[id].x<<"\t"<<hold<<"\t";
				if(id < offset)
					g[id].sety(0.0f);
				else if( id-offset < rhs.sz(ch1) )
				{//cout<<rhs.get(ch1,1,id-offset)<<"\t";
					hold *= rhs.get(ch1,1,id-offset);
					g[id].sety(hold);
				}
				else
					g[id].sety(0.0f);
				//cout<<g[id].y<<endl;
			}//cout<<sum<<endl<<endl;
		break;
		
		case 2:
		offset = (int)(rhs.get(ch1,0,0) - 380)/10;
			for(int id = 0; id < b.size(); ++id)
			{sum+=hold;
			hold = b[id].y;//cout<<b[id].x<<"\t"<<hold<<"\t";
				if(id < offset)
					b[id].sety(0.0f);
				else if( id-offset < rhs.sz(ch1) )
				{//cout<<rhs.get(ch1,1,id-offset)<<"\t";
					hold *= rhs.get(ch1,1,id-offset);
					b[id].sety(hold);
				}
				else
					b[id].sety(0.0f);
				//cout<<b[id].y<<endl;
			}//cout<<sum<<endl<<endl;
		break;
		
		default:
			break;
	}
}

void curvy::delog_ch(int ch, bool xy)
{
	switch(ch)
	{
		case 0:
			if(!xy)
			{
				for(int id = 0; id < r.size(); ++id)
					r[id].setx( 1 / pow(10,r[id].x) );
			
			}
			else
			{
				for(int id = 0; id < r.size(); ++id)
					r[id].sety( 1 / pow(10,r[id].y) );
			}
		break;
		
		case 1:
			if(!xy)
			{
				for(int id = 0; id < g.size(); ++id)
					g[id].setx( 1 / pow(10,g[id].x) );
			
			}
			else
			{
				for(int id = 0; id < g.size(); ++id)
					g[id].sety( 1 / pow(10,g[id].y) );
			}
		break;
		
		case 2:
			if(!xy)
			{
				for(int id = 0; id < b.size(); ++id)
					b[id].setx( 1 / pow(10,b[id].x) );
			
			}
			else
			{
				for(int id = 0; id < b.size(); ++id)
					b[id].sety( 1 / pow(10,b[id].y) );
			}
		break;
		
		default:
			break;
	}
}

void curvy::delogx()
{
	delog_ch(0,0);
	delog_ch(1,0);
	delog_ch(2,0);
}

void curvy::delogy()
{
	delog_ch(0,1);
	delog_ch(1,1);
	delog_ch(2,1);
}

curvy curvy::operator * (curvy &rhs)
{
curvy temp;
double hold;
int offset = (int)(rhs.get(0,0,0) - 380)/10;

int ch = 0;
	for(int id = 0; id < r.size(); ++id)
	{
	hold = r[id].y;
		if(id < offset)
			r[id].sety(hold * rhs.get(ch,1,0));
		else if( id-offset < rhs.sz(ch) )
		{
			hold *= rhs.get(ch,1,id-offset);
			r[id].sety(hold);
		}
		else
			r[id].sety(hold * rhs.get(ch,1,rhs.sz(ch)-1));
	}
	
ch = 1;
	for(int id = 0; id < g.size(); ++id)
	{
	hold = g[id].y;
		if(id < offset)
			g[id].sety(hold * rhs.get(ch,1,0));
		else if( id-offset < rhs.sz(ch) )
		{
			hold *= rhs.get(ch,1,id-offset);
			g[id].sety(hold);
		}
		else
			g[id].sety(hold * rhs.get(ch,1,rhs.sz(ch)-1));
	}
	
ch = 2;
	for(int id = 0; id < b.size(); ++id)
	{
	hold = b[id].y;
		if(id < offset)
			b[id].sety(hold * rhs.get(ch,1,0));
		else if( id-offset < rhs.sz(ch) )
		{
			hold *= rhs.get(ch,1,id-offset);
			b[id].sety(hold);
		}
		else
			b[id].sety(hold * rhs.get(ch,1,rhs.sz(ch)-1));
	}

return temp;
}

curvy curvy::operator + (const curvy &rhs)
{
//if();
}

void curvy::fprint_ch(string filename, int ch)
{
ofstream fileout;
string append;
int i = 0;
	switch(ch)
	{
		case 0:
			append = ".r";
			filename.insert(filename.size(),append);//add colour extension
			fileout.open(filename.c_str(),ios::out);
			for(i = 0; i < r.size(); ++i)
			{
				fileout<<r[i].x<<"\t"<<r[i].y<<endl;
			}
			break;
		case 1:
			append = ".g";
			filename.insert(filename.size(),append);//add colour extension
			fileout.open(filename.c_str(),ios::out);
			for(i = 0; i < g.size(); ++i)
			{
				fileout<<g[i].x<<"\t"<<g[i].y<<endl;
			}
			break;
		case 2:
			append = ".b";
			filename.insert(filename.size(),append);//add colour extension
			fileout.open(filename.c_str(),ios::out);
			for(i = 0; i < b.size(); ++i)
			{
				fileout<<b[i].x<<"\t"<<b[i].y<<endl;
			}
			break;
		default:
			break;
	}
	cout<<filename<<" : successfully written"<<endl;
	fileout.close();
}

void curvy::fprint(string filename)
{
	fprint_ch(filename,0);
	fprint_ch(filename,1);
	fprint_ch(filename,2);
}

void curvy::invertx_ch(int ch)
{
double hold = 0.0f;

	switch(ch)
	{
	case 0:
		for(int i = 0 ;i < r.size()/2 ; ++i)
		{
			hold = r[i].x;
			r[i].x = r[r.size()-i].x;
			r[r.size()-i].x = hold;
		}
	break;
	
	case 1:
		for(int i = 0 ;i < g.size()/2 ; ++i)
		{
			hold = g[i].x;
			g[i].x = g[g.size()-i].x;
			g[g.size()-i].x = hold;
		}
	break;
	
	case 2:
		for(int i = 0 ;i < b.size()/2 ; ++i)
		{
			hold = b[i].x;
			b[i].x = b[b.size()-i].x;
			b[b.size()-i].x = hold;
		}
	break;
	
	default:
		break;
	}
}

void curvy::inverty_ch(int ch)
{
double hold = 0.0f;

	switch(ch)
	{
	case 0:
		for(int i = 0 ;i < r.size()/2 ; ++i)
		{
			hold = r[i].y;
			r[i].y = r[r.size()-i].y;
			r[r.size()-i].y = hold;
		}
	break;
	
	case 1:
		for(int i = 0 ;i < g.size()/2 ; ++i)
		{
			hold = g[i].y;
			g[i].y = g[g.size()-i].y;
			g[g.size()-i].y = hold;
		}
	break;
	
	case 2:
		for(int i = 0 ;i < b.size()/2 ; ++i)
		{
			hold = b[i].y;
			b[i].y = b[b.size()-i].y;
			b[b.size()-i].y = hold;
		}
	break;
	
	default:
		break;
	}
}

void curvy::invertx()
{
	invertx_ch(0);
	invertx_ch(1);
	invertx_ch(2);
}

void curvy::inverty()
{
	inverty_ch(0);
	inverty_ch(1);
	inverty_ch(2);
}


int curvy::max_y(int ch)
{
int max = 0;
	switch(ch)
	{
		case 0:
			for(int id = 0; id < r.size(); ++id)
				if(r[id].y > r[max].y) max = id;
		break;
		
		case 1:
			for(int id = 0; id < g.size(); ++id)
				if(g[id].y > g[max].y) max = id;
		break;
		
		case 2:
			for(int id = 0; id < b.size(); ++id)
				if(b[id].y > b[max].y) max = id;
		break;
		
		default:
			break;
	}
return max;
}

int curvy::min_y(int ch)
{
int min = 0;
	switch(ch)
	{
		case 0:
			for(int id = 0; id < r.size(); ++id)
				if(r[id].y < r[min].y) min = id;
		break;
		
		case 1:
			for(int id = 0; id < g.size(); ++id)
				if(g[id].y < g[min].y) min = id;
		break;
		
		case 2:
			for(int id = 0; id < b.size(); ++id)
				if(b[id].y < b[min].y) min = id;
		break;
		
		default:
			break;
	}
return min;
}

double curvy::sum_y(int ch)
{
double sum = 0.0f;
	switch(ch)
	{
		case 0:
			for(int id = 0; id < r.size(); ++id)
				sum += r[id].y;
		break;
		
		case 1:
			for(int id = 0; id < g.size(); ++id)
				sum += g[id].y;
		break;
		
		case 2:
			for(int id = 0; id < b.size(); ++id)
				sum += b[id].y;
		break;
		
		default:
			break;
	}
return sum;
}

double curvy::sum_x(int ch)
{
double sum = 0.0f;
	switch(ch)
	{
		case 0:
			for(int id = 0; id < r.size(); ++id)
				sum += r[id].x;
		break;
		
		case 1:
			for(int id = 0; id < g.size(); ++id)
				sum += g[id].x;
		break;
		
		case 2:
			for(int id = 0; id < b.size(); ++id)
				sum += b[id].x;
		break;
		
		default:
			break;
	}
return sum;
}

void curvy::flip_y(int ch)
{
int max_id = max_y(ch);
int min_id = min_y(ch);
double max=0.0f,min=0.0f;
	switch(ch)
	{
		case 0:
		max=r[max_id].y;
		min=r[min_id].y;
			for(int id = 0; id < r.size(); ++id)
				r[id].sety( max - r[id].y + min);
		break;
		
		case 1:
		max=g[max_id].y;
		min=g[min_id].y;
			for(int id = 0; id < g.size(); ++id)
				g[id].sety( max - g[id].y + min);
		break;
		
		case 2:
		max=b[max_id].y;
		min=b[min_id].y;
			for(int id = 0; id < b.size(); ++id)
				b[id].sety( max - b[id].y + min);
		break;
		
		default:
			break;
	}
}

