#ifndef __curvecpp__
#define __curvecpp__

#include <string>
#include <vector>

#include "point.h"
#include "curve.h"

/*class to store three sets of point value pairs
**and the operations to perform on them*/
using namespace std;
class curvy
{
	private:
		vector<point> r;
		vector<point> g;
		vector<point> b;
	public:
		curvy();
		curvy(string rfile,string gfile,string bfile);
		~curvy();
		
		const curvy& curvy::operator = (const curvy &rhs);
		
		void read_ch(string filename, int ch);
		void read(string rfile,string gfile,string bfile);
		
		void print_ch(int ch);
		void print();
		void scale(char ch, char xy, double val);
		void fit_ch_x(int ch, double hi, double lo);
		void fit_ch_y(int ch, double hi, double lo);
		void fit_x(double hi, double lo);
		void fit_y(double hi, double lo);
		
		double sum_x(int ch);
		double sum_y(int ch);
		
		void fprint_ch(string filename, int ch);
		void fprint(string filename);
		
		double get(char ch, char xy, char id);
		double setx(char ch, char id, double val);
		double sety(char ch, char id, double val);
		int sz(int id);
		
		void mult_ch(curvy rhs, int ch, int ch1);
		void delog_ch(int ch, bool xy);
		void delogx();
		void delogy();
		//void add_ch(
		void invertx_ch(int ch);
		void inverty_ch(int ch);
		void invertx();
		void inverty();
		
		void flip_y(int ch);
		void sum_channels();
		
		int max_y(int ch);
		int min_y(int ch);
		curvy operator * (curvy &rhs);
		curvy operator + (const curvy &rhs);
};

#endif




