#include <iostream>
#include <math.h>
#include "matrix.h"
using namespace std;

matrix::matrix()
{
	for(int i = 0; i < 4; ++i)
	{
		for(int j = 0; j < 4; ++j)
			data[i][j] = 0.0f;
	}
}

matrix::matrix(	double _00,double _01,double _02,double _03,
		double _10,double _11,double _12,double _13,
		double _20,double _21,double _22,double _23,
		double _30,double _31,double _32,double _33)
{
	data[0][0]=_00;	data[0][1]=_01;	data[0][2]=_02;	data[0][3]=_03;
	data[1][0]=_10;	data[1][1]=_11;	data[1][2]=_12;	data[1][3]=_13;
	data[2][0]=_20;	data[2][1]=_21;	data[2][2]=_22;	data[2][3]=_23;
	data[3][0]=_30;	data[3][1]=_31;	data[3][2]=_32;	data[3][3]=_33;
}

matrix::~matrix()
{

}

void matrix::invert()
{
matrix cm;
double a,b,c,d,e,f,det;
int ri,ci;

a = data[2][2] * data[3][3] - data[3][2] * data[2][3];
b = data[1][2] * data[3][3] - data[3][2] * data[1][3];
c = data[1][2] * data[2][3] - data[2][2] * data[1][3];
d = data[0][2] * data[3][3] - data[3][2] * data[0][3];
e = data[0][2] * data[2][3] - data[2][2] * data[0][3];
f = data[0][2] * data[1][3] - data[1][2] * data[0][3];

cm.set(0,0, data[1][1] * a - data[2][1] * b + data[3][1] * c);
cm.set(1,0, data[2][1] * d - data[0][1] * a - data[3][1] * e);
cm.set(2,0, data[0][1] * b - data[1][1] * d + data[3][1] * f);
cm.set(3,0, data[1][1] * e - data[0][1] * c - data[2][1] * f);

cm.set(0,1, data[2][0] * b - data[1][0] * a + data[3][0] * c);
cm.set(1,1, data[0][0] * a - data[2][0] * d - data[3][0] * e);
cm.set(2,1, data[1][0] * d - data[0][0] * b + data[3][0] * f);
cm.set(3,1, data[0][0] * c - data[1][0] * e - data[2][0] * f);

a = data[2][1] * data[3][3] - data[3][1] * data[2][3];
b = data[1][1] * data[3][3] - data[3][1] * data[1][3];
c = data[1][1] * data[2][3] - data[2][1] * data[1][3];
d = data[0][1] * data[3][3] - data[3][1] * data[0][3];
e = data[0][1] * data[2][3] - data[2][1] * data[0][3];
f = data[0][1] * data[1][3] - data[1][1] * data[0][3];

cm.set(0,2, data[1][0] * a - data[2][0] * b + data[3][0] * c);
cm.set(1,2, data[2][0] * d - data[0][0] * a - data[3][0] * e);
cm.set(2,2, data[0][0] * b - data[1][0] * d + data[3][0] * f);
cm.set(3,2, data[1][0] * e - data[0][0] * c - data[2][0] * f);

a = data[2][1] * data[3][2] - data[3][1] * data[2][2];
b = data[1][1] * data[3][2] - data[3][1] * data[1][2];
c = data[1][1] * data[2][2] - data[2][1] * data[1][2];
d = data[0][1] * data[3][2] - data[3][1] * data[0][2];
e = data[0][1] * data[2][2] - data[2][1] * data[0][2];
f = data[0][1] * data[1][2] - data[1][1] * data[0][2];

cm.set(0,3, data[2][0] * b - data[1][0] * a - data[3][0] * c);
cm.set(1,3, data[0][0] * a - data[2][0] * d + data[3][0] * e);
cm.set(2,3, data[1][0] * d - data[0][0] * b - data[3][0] * f);
cm.set(3,3, data[0][0] * c - data[1][0] * e + data[2][0] * f);

det = data[0][0]*cm.get(0,0) + data[1][0]*cm.get(1,0) + data[2][0]*cm.get(2,0) + data[3][0]*cm.get(3,0);

	if(fabs(det) <= IEEE_small_single)
	{
		cout<<"matrix is singular - unlucky\n";
		return;
	}
	
	for(ri = 0; ri < 4; ri++)
	{
		for(ci = 0; ci < 4; ci++)
		{
			data[ri][ci] = cm.get(ci,ri) / det;
		}
	}
}

void matrix::set(int r,int c,double val)
{
	data[r][c] = val;
}

void matrix::setall(double _00,double _01,double _02,double _03,
		double _10,double _11,double _12,double _13,
		double _20,double _21,double _22,double _23,
		double _30,double _31,double _32,double _33)
{
	data[0][0]=_00;	data[0][1]=_01;	data[0][2]=_02;	data[0][3]=_03;
	data[1][0]=_10;	data[1][1]=_11;	data[1][2]=_12;	data[1][3]=_13;
	data[2][0]=_20;	data[2][1]=_21;	data[2][2]=_22;	data[2][3]=_23;
	data[3][0]=_30;	data[3][1]=_31;	data[3][2]=_32;	data[3][3]=_33;
}

void matrix::print()
{
	for(int i = 0; i < 4; ++i)
	{
		for(int j = 0; j < 4; ++j)
			cout<<data[i][j]<<"\t";
		cout<<endl;
	}
	cout<<endl;
}

double matrix::get(int r, int c)
{
	return data[r][c];
}


