#include <iostream>
#include <iomanip>
#include <fstream>
#include <math.h>
#include <stdlib.h>
#include <signal.h>
#include <assert.h>

#ifdef __cplusplus
extern "C" {
#endif

#include "lib/NCCAPixmap.h"
#include "lib/PixFileIO.h"

#ifdef __cplusplus
}
#endif

#define REALLY_SMALL 0.0001

using namespace std;

int read_curve(char* filename);
bool is_roughly(double n1, double n2);

int main(int argc, char*argv[])
{
if(argc!=2)
		{
		cerr<<"read_graph"<<endl;
		cerr<<"read_graph imagefile"<<endl;
		exit(1);
		}

read_curve(argv[1]);

return 0;
}


int read_curve(char* filename)
{
NCCAPixmap graph;
NCCAPixel p;		
int c=0;
double min_x,max_x,min_y,max_y,inc_x,inc_y;
char base='x';

graph = loadPixmap(filename);
if(graph.data==NULL)
		{
		cerr<<"Couldn't load "<<filename<<endl;
		exit(1);
		}

cout<<"enter graph min x value"<<endl;
cin>>min_x;
cout<<"enter graph max x value"<<endl;
cin>>max_x;
cout<<"enter graph min y value"<<endl;
cin>>min_y;
cout<<"enter graph max y value"<<endl;
cin>>max_y;
cout<<"enter base axis (x|y)"<<endl;
cin>>base;

if(base=='x')
{
	cout<<"enter size of x increment"<<endl;
	cin>>inc_x;
}
else
{
	cout<<"enter size of y increment"<<endl;
	cin>>inc_y;
}

//cout<<min_x<<" "<<max_x<<" "<<min_y<<" "<<max_y<<" "<<inc_x<<" "<<inc_y<<endl;

double val_x=min_x,val_y=min_y;

char ext[]={".cv"};
strcat(filename,ext);//cout<<filename<<endl;
fstream fileout;
fileout.open(filename,ios::out);

if(!fileout.is_open())
	{
	cout<<"File : "<<filename<<" does not exist"<<endl;
	exit(1);
	}

if(base == 'x')
{
double pix_offset = ((inc_x/(max_x-min_x))*(double)graph.width);cout<<pix_offset<<endl;

	for(double i=0; i<(double)graph.width; i+=pix_offset)
	{
		for(int j=0; j<graph.height; j++)
		{
			p=getPixel(graph,(int)i,j);//cout<<p.r<<"\t"<<p.g<<"\t"<<p.b<<endl;
			if(p.r<0.1)
			{
				while((p.r<0.1)&&((j+c)<graph.height))
				{//cout<<p.r<<"\t"<<p.g<<"\t"<<p.b<<"\t"<<endl;
					++c;
					p=getPixel(graph,(int)i,j+c);
				}
				val_y=(double)graph.height-(double)j+c/2;
				val_y=(val_y/(double)graph.height)*(max_y-min_y)+min_y;
				j+=c;
				/*cout	<<setiosflags( ios::showpoint )
					<<setprecision(2)<<setw(3)
					<<val_y<<"\t"
					<<setprecision(5)
					<<val_x<<"\t"<<c<<"\t"<<i<<"\t"<<j<<endl;*/
				fileout	<<setiosflags( ios::showpoint )
					<<setprecision(2)<<setw(3)
					<<val_x<<"\t"
					<<setprecision(5)
					<<val_y<<endl;
				c=0;
			}
		}
		val_x+=inc_x;
		if(is_roughly(val_x,0.0))
			val_x=0.0;
	}
}

else if(base == 'y')
{
double pix_offset = (inc_y/(max_y-min_y))*(double)graph.height;cout<<pix_offset<<endl;

	for(double i=graph.height; i>=0; i-=pix_offset)
	{
		for(int j=0; j<graph.width; j++)
		{
			p=getPixel(graph,j,(int)i);//cout<<p.r<<"\t"<<p.g<<"\t"<<p.b<<endl;
			if(p.r<0.5)
			{
				while((p.r<0.5)&&((j+c)<graph.width))
				{//cout<<p.r<<"\t"<<p.g<<"\t"<<p.b<<"\t"<<endl;
					++c;
					p=getPixel(graph,j+c,(int)i);
				}
				val_x=(double)j+c/2;
				val_x=(val_x/(double)graph.width)*(max_x-min_x)+min_x;
				j+=c;
				/*cout	<<setiosflags( ios::showpoint )
					<<setprecision(2)<<setw(3)
					<<val_y<<"\t"
					<<setprecision(5)
					<<val_x<<"\t"<<c<<"\t"<<i<<"\t"<<j<<endl;*/
				fileout	<<setiosflags( ios::showpoint )
					<<setprecision(4)<<setw(3)
					<<val_x<<"\t"
					<<setprecision(5)
					<<val_y<<endl;
				c=0;
			}
		}
		val_y+=inc_y;//cout<<val_y<<endl;
		if(is_roughly(val_y,0.0))
			val_y=0.0;cout<<"val_y : "<<val_y<<endl;
	}
}

fileout.close();
cout<<endl<<filename<<" : successfully written"<<endl<<endl;

return 0;
}

bool is_roughly(double n1, double n2)
{
	if(fabs(n1-n2)<REALLY_SMALL)
		return true;
	else
		return false;
}




